package Statistics;

use vars qw(
$MultiQueueStatus $MultiQueueDateFormat @MultiQueueQueueList $MultiQueueMaxRows $MultiQueueWeekends $MultiQueueLabelDateFormat
$PerDayStatus $PerDayDateFormat $PerDayQueue $PerDayMaxRows $PerDayWeekends $PerDayLabelDateFormat
$DayOfWeekQueue
@OpenStalledQueueList $OpenStalledWeekends
$TimeToResolveDateFormat $TimeToResolveQueue $TimeToResolveMaxRows $TimeToResolveWeekends $TimeToResolveLabelDateFormat
$TimeToResolveGraphQueue
);

use Time::Local;

# I couldn't figure out a way to override these in RT_SiteConfig, which would be
# preferable.

# Initial settings for the CallsMultiQueue stat page
$MultiQueueStatus = "resolved";
$MultiQueueDateFormat = "%a %b %d";  # format for dats on Multi Queue report, see "man sttrftime" for options
@MultiQueueQueueList = ("General"); # list of queues to start Multi Queue per day reports
$MultiQueueMaxRows = 10;
$MultiQueueWeekends = 1;
$MultiQueueLabelDateFormat = "%a";

# Initial settings for the CallsQueueDay stat page
$PerDayStatus = "resolved";
$PerDayDateFormat = "%a %b %d";
$PerDayQueue = "General";
$PerDayMaxRows = 10;
$PerDayWeekends = 1;
$PerDayLabelDateFormat = "%a";

# Initial settings for the DayOfWeek stat page
$DayOfWeekQueue = "General";

# Initial settings for the OpenStalled stat page
@OpenStalledQueueList = ("General"); 
$OpenStalledWeekends = 1;

# Initial settings for the TimeToResolve stat page
$TimeToResolveDateFormat = "%a %b %d"; 
$TimeToResolveQueue = "General";
$TimeToResolveMaxRows = 10;
$TimeToResolveWeekends = 1;
$TimeToResolveLabelDateFormat = "%a";

# Initial settings for the TimeToResolve Graph page
$TimeToResolveGraphQueue = "General";

=head2 FormatDate 

Returns a string representing the specified date formatted by the specified string

=cut
sub FormatDate {
    my $fmt = shift;
    my $self = shift;
    return POSIX::strftime($fmt, localtime($self->Unix));
}


=head2 RTDateSetToLocalMidnight

Sets the date to midnight (at the beginning of the day) local time
Returns the unixtime at midnight.

=cut
sub RTDateSetToLocalMidnight {
    my $self = shift;
    
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday) = localtime($self->Unix);
    $self->Unix(timelocal (0,0,0,$mday,$mon,$year,$wday,$yday));
    
    return ($self->Unix);
}

=head2 RTDateIsWeekend

Returns 1 if the date is on saturday or sunday

=cut
sub RTDateIsWeekend {
    my $self = shift;
    
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday) = localtime($self->Unix);
    return 1 if (($wday==6) || ($wday==0));
    0;
}

=head2 RTDateGetDateWeekday

Returns the localized name of the day specified by date

=cut
sub RTDateGetDateWeekday {
    my $self = shift;
    
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday) = localtime($self->Unix);
    return $self->GetWeekday($wday);
}

=head2 RTDateSubDay

Subtracts 24 hours from the current time

=cut

sub RTDateSubDay {
    my $self = shift;
    $self->AddSeconds(0 - $DAY);
}

=head2 RTDateSubDays $DAYS

Subtracts 24 hours * $DAYS from the current time

=cut

sub RTDateSubDays {
    my $self = shift;
    my $days = shift;
    $self->AddSeconds(0 - ($days * $DAY));
}

1;
